#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

uint8_t SlaveAdress = 0;

void TWI_send(uint8_t byte, uint8_t adress);
uint8_t TWI_receive(uint8_t adress);	//todo
void setSlaveAdress(uint8_t adress);


int main( void )
{
	DDRD = (1<<PD7);	//LED
	DDRC = (1<<PC0) | (1<<PC1);	//SDA und SCL
	
	TWBR = 0x17;
	TWCR = (1<<TWEN);// | (1<<TWIE);
	
	
	setSlaveAdress(0x66);
	TWI_send(0,0);	//init
	
	
	//initial_88.6MHZ
	TWI_send(0x02, 0x00);
	TWI_send(0x81, 0x01);
	TWI_send(0x0A, 0x02);
	TWI_send(0x00, 0x03);
	TWI_send(0x00, 0x04);
	TWI_send(0x00, 0x05);
	TWI_send(0x00, 0x06);
	TWI_send(0x7E, 0x07);
	TWI_send(0x0E, 0x08);
	TWI_send(0x08, 0x09);
	TWI_send(0x3F, 0x0A);	//test
	TWI_send(0x2A, 0x0B);	//test
	//TWI_send(0xAF, 0x0A);
	//TWI_send(0x2F, 0x0B);
	TWI_send(0x0C, 0x0C);
	TWI_send(0xE6, 0x0D);
	TWI_send(0x3F, 0x0E);
	TWI_send(0x70, 0x0F);
	TWI_send(0x0A, 0x10);
	TWI_send(0xE4, 0x11);
	TWI_send(0x00, 0x12);
	TWI_send(0x42, 0x13);
	TWI_send(0xC0, 0x14);
	TWI_send(0x41, 0x15);
	TWI_send(0xF4, 0x16);
	
	
	//start
	TWI_send(0x0B, 0x02);
	//TWI_send(0x03, 0x00);	//Modul aktivieren
	TWI_send(0x11, 0x15);
	TWI_send(0xE0, 0x10);

	//parametrierung
	TWI_send(0x0B, 0x02);
	TWI_send(0x3F, 0x0A);
	TWI_send(0x2A, 0x0B);
	TWI_send(0x7E, 0x07);
	TWI_send(0x0E, 0x08);

	TWI_send(0x0A, 0x02);
	TWI_send(0x81, 0x01);
	
	TWI_send(0x03, 0x00);	//Modul aktivieren
	
	
	PORTD |= (1<<PD7);
	
	
	while(1);
}



void TWI_send(uint8_t byte, uint8_t adress)
{
	
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN);	//START
	
	while(!(TWCR & (1<<TWINT)));
	
	TWDR = SlaveAdress | 0x00;
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	while(!(TWCR & (1<<TWINT)));
	
	TWDR = adress;
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	while(!(TWCR & (1<<TWINT)));
	
	TWDR = byte;
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	while(!(TWCR & (1<<TWINT)));
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
	_delay_ms(1);
	
}

uint8_t TWI_receive(uint8_t adress)
{
	//zurzeit noch nicht genutzt
	return 0;
}

void setSlaveAdress(uint8_t adress)
{
	SlaveAdress = adress << 1;
}
